/*
 * Copyright (c) 2016 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _NETLINK_H
#define _NETLINK_H

extern int netlink_socket(void);
extern int get_interfaces(int fd);
extern int recv_netlink(int fd);
extern int route_add(int fd, struct in_addr *dst, int prefix,
    struct in_addr *gw, int ifindex);
extern int route_del(int fd, struct in_addr *dst, int prefix,
    struct in_addr *gw, int ifindex);
extern int link_up(int fd, int ifindex, bool up);
extern int link_mtu(int fd, int ifindex, int mtu);
extern int link_delete(int fd, int ifindex);
extern int address_add(int fd, int ifindex,
    struct in_addr *local, struct in_addr *remote);

#endif
